var CGIBIN	=  "cgi-bin/";
var CGINAME	=  "pac7-exercise.cgi";
var CGIDIR	=  "/"  +  location.pathname.split("/", 2)[1]
		+  "/"  +  CGIBIN ;
var CGI		=  CGIDIR  +  CGINAME;

// for short
var enc = encodeURIComponent;
var dec = decodeURIComponent;
var httpObj;               // HTTP communication object
var timerId = null;               // HTTP communication timer object
var timeout_sec_init = 300;      // HTTP communication timeout seconds
var timeout_sec;
var Requests = new Array();
var inputTagCount = 0;
var debug = false;
var QAcount = 0;
var ansWin = null;
var Answers = new Array();
var showWordsButtonCount=0;
var default_parameters_for_request;
var img_head =  "<img src=\"" +  CGIDIR +  "mimetex.cgi?" ;
var img_tail =  "\">" ;

function just(e) {return e; }
function dol(e) {return (img_head + escape(e) + img_tail); }

// for debug
function dump(obj) {
    var properties = "";
    for (var prop in obj){
        properties += prop + "=" + obj[prop] + "\n";
    }
}

function ans(Ans, button_label, LMR) {
    var b= (button_label == null) ? "==&gt": button_label;
    b = (b == "") ? "''": b;
    answer(Ans, "replaceInnerHTML", b, "span", LMR);}

function ans0(Ans, button_label, LMR) {
    var b= (button_label == null) ? "==&gt": button_label;
    b = (b == "") ? "''": b;
    answer(Ans, "replaceInnerHTML0", b, "span", LMR);}

function answin(Ans) {answer(Ans, "ansWinWrite", "==&gt;", null);}
function ansframe(Ans) {answer(Ans, "ansFrameWrite", "==&gt;", null);}
function mimetex(e){document.write(mimetexcode(e));}
function addtotext(x, y) { y.value = y.value + x.value;}
function addnewlinetext(x, y) { y.value = y.value + x.value + "\n";}
function copytotext(x, y) {y.value = x.value;}
function cleartotext(y) {y.value = new String("");}
function setvalue(x,v) {document.getElementById(x).value= v;}
function getvalue(x) {return document.getElementById(x).value;}

// Apply default to requests.

function setup_default() {
    default_parameters_for_request = {
	area:		"",		// list of text area's ids
	label:		"==&gt;",	// button lable
	url:		CGI,		// Prolog CGI
	filter:		setInnerHTML,	// filter
	div:		"span",
	params :	[],
	makeup:		makeup_for_eval,
	build:		make_request,
	specific:	create_request,
	pre_input_tag:	"",	// optional padding for centering of buttons
	post_input_tag: "",	// optional padding for centering of buttons
	pre_write:	pre_write,
	post_write:	post_write,
	post:		"<br>",
	print:		print_request
    }
}

// main wrapper of Ajax call to evaluate expressions by Prolog.
function eval_obj(E){
    var j ;
    j = push_request(E) ;
    var Q = Requests[j];
    Q.exp0 = Q.exp;  // keep original
    apply_default_request(Q);
    Q.makeup(Q) ;  // modify input main expression
    Q.build(Q);    // create common parts of request
    Q.specific(Q); // specific parts
    Q.pre_write(Q);
    Q.print(Q);    // print input tag and division tag
    Q.post_write(Q);
   dump(Q);    // for debug
}

// a handy wrapper of the eval_obj above.
function ev(x, e){
    var e0;
    if (e == null) e0 =x;
    else {e0 = e; e0.exp = x;}
    eval_obj(e0);
}

// for compatibility with old version
function ap(P, X, E) {
    E.exp = "($(" + X + "), " + "(" +  P + "))";
    eval_obj(E); }

function act(x1,x2,y,z,u,v,w) {
    ap(x1, x2, {area: y, label: z, url:u, filter:v, div:w});
}

function let(p, e) {e.params = p; eval_obj(e);}

function makeup_for_eval(Q){}  //dummy

function apply_default_request(q) {
    apply_default(default_parameters_for_request, q);
}

function apply_default(d, o) {
    for (var p in d ) if (o[p] == null) o[p]= d[p];
}

// A wrapper of the httpPostRequest.
function create_request(Q){
    Q.handlerName = "sendToProlog";
    Q.postreq  = function(){
	return 	Q.handlerName + "(" + Q.index + ")" ; };
    Q.inputTag = function(){ return "<input "
		    + " type=button"
		    + " class=button"
		    + " id=button"+ Q.index
		    + " value="   + "\""+ Q.label + "\""
		    + " onClick=" + "\""+ Q.postreq() + "\""
 		    + ">";};
    Q.ansTag  = function(){ return (Q.div == null) ? ""
	:  "<"+ Q.div + " id=ans"+ Q.index+ ">" + "</"+ Q.div +">"; };
    Q.writeInputTag =
	function(){document.write(	Q.pre_input_tag
					+ Q.inputTag()
					+ Q.post_input_tag
				 );};
    Q.writeAnsTag   = function(){document.write(Q.ansTag());};
    Q.send  =  function(bid,tid) {
	Q.params.push(["op", Q.op]);
	if (Q.syntax != null) Q.params.push(["syntax", Q.syntax]);
	var env  = Q.envBuilder(Q.index, Q);
   	var head =
	   "buttonid=" + bid +  "&"
 	 + "expr=" + encodeURIComponent(Q.expBuilder(Q.index,Q))+"&"
            + "targetid=" + tid ;
	httpPostRequest( Q.url,
	head + env + string_array_to_post_data(Q.params),
	Q.filter );
    };
}

// default methods
function push_request(Q){
   Q.index =  Requests.length;
   Requests.push(Q);
   return(Q.index);
}

function print_request(s){
	s.writeInputTag();
    	s.writeAnsTag();
}

// specific functions for eval,  let, ...  specific  features
function make_request(s){
    	s.expBuilder= function(j,q) {return q.exp;};
    	s.envBuilder= function(j,q) {return buildAssoc(q.area);};
}

function make_request_for_let(s){
    	s.expBuilder = function(j,q){
	  return
	   "let(@input" + j + "=" + q.param + "," +  q.exp + ")"; };
    	s.envBuilder = varBuildAssoc;
}

function pre_write(Q){
    if (Q.echo) document.write(Q.exp0 + "&nbsp;<br>");
	else document.write("<br>");
}

function post_write(Q){
	if (Q.post != null) document.write(Q.post);
}

// sending request
function sendToProlog(j) { Requests[j].send("button"+j, "ans"+j); }

function varSendToProlog(j) {
    document.getElementById("button"+j).disabled=true;
    Requests[j].send("button"+j, ""+ j);}

//// helper functions
function buildAssoc(env) {
    if (env.length==0) return env;
    var ids = env.split(";");
    var post_data_sub = "";
    var i;
    for(i = 0; i < ids.length; i++) {
         post_data_sub += "&"+ ids[i] + "=" +
	     encodeURIComponent(document.getElementById(ids[i]).value);
    }
    return post_data_sub;
}

// [["x", "ab"],["y", "cd"]] ==>  "&x=ab&y=cd"
function string_array_to_post_data(a) {
    var post_data_sub = "";
    var i;
    for(i = 0; i < a.length; i++) {
       post_data_sub += "&"+ a[i][0] + "=" + encodeURIComponent(a[i][1])
    }
    return post_data_sub;
}

function with_where_clause(Q) {
    document.write(Q.exp0 + " ,where " +
	string_array_to_equations(Q.params) + " "); }

function string_array_to_equations(a) {
	var b = "";
	var i;
	for(i=0; i < a.length; i++){
	    b +=  ((i==0) ? "": ", ") +  a[i][0] + " = " + a[i][1];
	}
    return b;
}

function varBuildAssoc(j, q) {
    var x = "&" + "input" + j + "=" + encodeURIComponent(q.input);
    var e = q.area;
    if (e.length==0) return x;  return buildAssoc(e)+ "&" + x;
}

// call-back functions (filters)
function openSubWindow() {
    if(ansWin != null) ansWin.close();
    ansWin = window.open("outputini.html", "subwin", "titlebar=no, " +
	 "menubar=no, " + "toolbar=no, " + "location=no, " +
	 "directories=no, " + "width=300, " + "height=250, " +
	 "resizable=yes" + "top=400" + "left=20");
}

// display
function varSetInnerHTML(x) {
 (new show(varToInnerHTML,x)).display();}

function varToInnerHTML(x) {
    var q = Requests[x.lines[2]];
    q.showSteps.words = x.lines.slice(3);
    q.showSteps.showNext();
}

function setResponse(x, name) {
    var x0 = x.split("\n");
    setvalue(name, dec(x0.slice(3).join("\n")));
    document.getElementById(x0[1]).disabled  = false;
}

function showInWindow(x) { (new show(toWindow, x)).display();}

function showInFrame(x) { (new show(toFrame, x)).display();}

function setInnerHTML(x) { (new show(toInnerHTML, x)).display();}

function show(f, x){
	var x0 = x.split("\n");
        var ansbody = decodeURIComponent(x0.slice(3).join("\n"));
	this.lines= x0.slice(0,3).concat(ansbody.split("\n"));
	this.display = function(){
          f(this);
          document.getElementById(this.lines[1]).disabled = false;};
}

function toWindow(x) {
    openSuappbWindow();
    ansWin.focus();
    ansWin.document.open();
    ansWin.document.clear();
    var i;
    for(i = 3; i < x.lines.length; i ++) {
	ansWin.document.write(x.lines[i]+"<br>");
        }
    ansWin.document.close();
}

function toFrame(x) {
    var i, code= "";
    for(i = 3; i < x.lines.length; i ++) {code += x.lines[i]+"<br>";}
    parent.frames['outputframe'].document.documentElement.innerHTML=code;
}

// create clickable button for showing answer
function answer(Expr, handlerName, button_label, Tag, LMR) {
    Requests.push(Expr);
    var j = Requests.length - 1;
    var did = (Tag == null) ? "": "ans" + j;
    var inner_HTML_tag = (Tag == null) ? "" :
	"<" + Tag + " id=" + did + "></" + Tag + ">";
    var inner_HTML_tag_begin = (Tag == null) ? "" :
	"<" + Tag + " id=" + did + ">";
    var inner_HTML_tag_end = (Tag == null) ? "" :
	"</" + Tag + ">";
    var handlerArgs = (Tag == null) ? j :
	j + "," + "'" + did + "'" ;
    if (LMR == "l" ) { document.write(inner_HTML_tag);}
    if (LMR == "m" ) { document.write(inner_HTML_tag_begin);}
        document.write(
	"  <a href=\"#\" class=\"button normal\""
	+  " onClick=" +  handlerName + "(" + handlerArgs + ")"
	+  ">" + button_label + "</a>");
    if ( LMR == null || LMR == "r" ) { document.write(inner_HTML_tag);}
    if ( LMR == "m" ) { document.write(inner_HTML_tag_end);}
}

//   one character space after button
function toInnerHTML(x) {
    document.getElementById(x.lines[2]).innerHTML =
	" "+ x.lines.slice(3).join("\n");
}

function replaceInnerHTML(j, tagId){
    document.getElementById(tagId).innerHTML = " " + Requests[j];
    MathJax.Hub.Queue(["Typeset",MathJax.Hub,tagId]);
}

function replaceInnerHTML0(j, tagId){
    document.getElementById(tagId).innerHTML = eval(Requests[j]);
    MathJax.Hub.Queue(["Typeset",MathJax.Hub,tagId]);
}

function ansWinWrite(j) {
    openSubWindow();
    ansWin.document.open();
    ansWin.document.clear();
    ansWin.document.write(Requests[j]);
    ansWin.focus();
    ansWin.document.close();
}

function ansFrameWrite(j){
parent.frames['outputframe'].document.documentElement.innerHTML=Request[j];
}

// for mimetex (obsolete ?)
function mimetexcode(e){
     return  "<img src=\""
	+  CGIDIR
	+ "mimetex.cgi?"
	+ escape(e)
        + "\""
        + ">";
}

//　次のコードは流布しているAjaxコードサンプルのコピー　内容は把握していない．
function httpPostRequest(target_url, post_data, functionReference) {
    try {
        if(window.XMLHttpRequest) {
            httpObj = new XMLHttpRequest();
        } else if(window.ActiveXObject) {
            httpObj = new ActiveXObject("Microsoft.XMLHTTP");
        } else {
           httpObj = false;
        }
    } catch(e) { httpObj = false; }
    if(! httpObj) { httpObjGenerateFail(); }
    // タイマーをセット
    if (timerId == null)
	{ timerId = setInterval('timeoutCheck()', 1000);}
    else
    { clearInterval(timerId); timerId = null; }
    httpObj.open("POST", target_url, true);
    httpObj.onreadystatechange = function() {
        if (httpObj.readyState == 4) {
            clearInterval(timerId);
            if (httpObj.status == 200) {
                functionReference(httpObj.responseText);
            } else {
                alert(httpObj.status + ' : ' + httpObj.statusText);
                return false;
            }
        }
    }
    timeout_sec = timeout_sec_init; // reset timer counter [2010/02/16]
    httpObj.send(post_data);
}

// Error handlling for creating XMLHttpRequest objects
function httpObjGenerateFail() {
    alert("Sorry, this site is not available with this browser. ");
    return false;
}

function timeoutCheck() {
    timeout_sec --;
    if(timeout_sec <= 0) {
        clearInterval(timerId);
        httpObj.abort();
	alert("Time Out. ");
        return false;
    }
}

setup_default();
