:- module(config, [expand_dir_name/2]).

expand_dir_name(X, Y):- dir_data(X, Y0), !,
	getenv(home, H),
	atomics_to_string([H, Y0], "/", Y).
expand_dir_name(X, X).

dir_data(home, "").
dir_data(tmp,   "tmp").
dir_data(pacpl7, "lib/swipl/pack/pac/prolog/pac").
dir_data(texmf,  "TeXLive/texmf-var").
dir_data(ptex,  "TeXLive/texmf-var/tex/latex/ptex").
dir_data(macro,  "TeXLive/texmf-var/tex/latex/ptex/private").
dir_data(bib,   "TeXLive/texmf-var/bibtex/bib").
dir_data(html,  "public_html").
dir_data(paccgi7, "public_html/paccgi7").
% dir_data(preambles,   "cabinet/TeX/preambles").
% dir_data(notes, "cabinet/notes/notes-in-tex").
